#!/bin/sh

uname=`uname`
if test ${uname} = "Darwin"; then
    shared_ext=".dylib"
    ld="cc -dynamiclib"
    install_name="-install_name "
elif test ${uname} = "SunOS"; then
    shared_ext=".so"
    ld="ld -G"
    install_name="-h "
elif test ${uname} = "Linux"; then
    shared_ext=".so"
    ld="ld -shared"
    install_name="-h"
else
    echo "Make.sh doesn't work on \"${uname}\""
    exit
fi

for name in "static1" "static2"; do
    rm -rf ${name}
    mkdir ${name}
    gcc -D${name} -c testlib.c -o ${name}/testlib.o
    ar rc ${name}/libtestlib.a ${name}/testlib.o
# After you copy one of the static libraries to /usr/lib, you may
# need to rerun ranlib on it.
    ranlib ${name}/libtestlib.a
done

for name in "dynamic1" "dynamic2"; do
    rm -rf ${name}
    rm -rf ${name}-usr-lib
    mkdir ${name}
    mkdir ${name}-usr-lib
    gcc -D${name} -c testlib.c -o ${name}/testlib.o
    ${ld} -o ${name}/libtestlib${shared_ext} \
	${install_name}`pwd`/${name}/libtestlib${shared_ext} \
	${name}/testlib.o -lc
# The libraries in ${name}-usr-lib are meant to be copied to /usr/lib
    ${ld} -o ${name}-usr-lib/libtestlib${shared_ext} \
	${install_name}/usr/lib/libtestlib${shared_ext} \
	${name}/testlib.o -lc
done

